<?

// Script de pilotage ampli Pioneer VSX
// réalisé par Connected Object
// vous pouvez améliorer ce script et en faire profiter la communauté eedomus

/*Volume:

    VD = VOLUME DOWN
    MZ = MUTE ON/OFF
    VU = VOLUME UP
    ?V = QUERY VOLUME

Power control:

    PF = POWER OFF
    PO = POWER ON
    ?P = QUERY POWER STATUS

Input selection

    05FN = TV/SAT
    01FN = CD
    03FN = CD-R/TAPE
    04FN = DVD
    19FN = HDMI1
    05FN = TV/SAT
    00FN = PHONO
    03FN = CD-R/TAPE
    26FN = HOME MEDIA GALLERY(Internet Radio)
    15FN = DVR/BDR
    05FN = TV/SAT
    10FN = VIDEO 1(VIDEO)
    14FN = VIDEO 2
    19FN = HDMI1
    20FN = HDMI2
    21FN = HDMI3
    22FN = HDMI4
    23FN = HDMI5
    24FN = HDMI6
    25FN = BD
    17FN = iPod/USB
    FU = INPUT CHANGE (cyclic)
    ?F = QUERY INPUT
*/

$GLOBALS['ip'] = getArg('ip');
$GLOBALS['port'] = getArg('port');

function sdk_get_vol($round = true)
{
  $output = netSend($GLOBALS['ip'], $GLOBALS['port'], '?V');
  $volume = str_replace('VOL', '', $output[0])/2;
  
  if ($round)
  {
    $volume  = round($volume / 10, 0) * 10;
  }
  return $volume;
}

if ($_GET['power'] != '')
{
  if ($_GET['power'] == 'off')
  {
    $output = netSend($GLOBALS['ip'], $GLOBALS['port'], 'PF');
  }
  else if ($_GET['power'] == 'on')
  {
    $output = netSend($GLOBALS['ip'], $GLOBALS['port'], 'PO');
  }
  $volume = sdk_get_vol();
}
else if ($_GET['input'] != '')
{
  $output = netSend($GLOBALS['ip'], $GLOBALS['port'], $_GET['input']);
  $volume = sdk_get_vol();
}
else if ($_GET['vol_offset'] != '')
{
  $volume = sdk_get_vol(false);
  
  if ($_GET['vol_offset'] > 0)
  {
    $c = 'VU';
  }
  else
  {
    $c = 'VD';
  }
  
  for ($i = 0; $i < abs($_GET['vol_offset']); $i++)
  {
    $output = netSend($GLOBALS['ip'], $GLOBALS['port'], $c);
  }
  
  $volume = $volume + $_GET['vol_offset'];
}
else if ($_GET['volume'] != '')
{
  $volume = sdk_get_vol(false);
  
  if ($volume === '') { die('ERR'); }
  $target_volume = $_GET['volume']*1;
  
  if ($target_volume > $volume)
  {
    $c = 'VU';
  }
  else
  {
    $c = 'VD';
  }
  
  $offset = abs($target_volume - $volume);
  for ($i = 0; $i < $offset; $i++)
  {
    $output = netSend($GLOBALS['ip'], $GLOBALS['port'], $c);
  }
  
  $volume = $target_volume;
}
else
{
  $volume = sdk_get_vol();
}

echo '{"volume":"'.$volume.'"}';

?>